local _,L = ...
local rematch = Rematch
local rematchsettings = RematchSettings
local old_PLAYER_TARGET_CHANGED = rematch.PLAYER_TARGET_CHANGED
local saved
local framebattle
local framelog
--iekava = 3
--myAllianceroutetemp = {}
--myHorderoutetemp = {}
local route
--format for route
--{
--[NPC ID for current target] = NPC ID for the next target
--}
--get the NPC IDs for trainers from, for example, NPCs.txt
local allianceDefaultRoute = {}
allianceDefaultRoute = {
	[87124] = 87123,
	[87123] = 87125,
	[87125] = 83837,
	[83837] = 87122,
	[87122] = 87110,
}

local hordeDefaultRoute = {}
hordeDefaultRoute = {
	--Draenor
	[79858] = 87122,
	[87122] = 83837,
	[83837] = 87125,
	[87125] = 87123,
	[87123] = 87124,
	[87124] = 87110,
}

local function mergetables(prio1,prio2)
	local temp = {}
	for i, v in ipairs(prio2) do
		if not prio1[i] then
			prio1[i] = prio2[i]
		end
    end
	temp = prio1
	return temp
end

local function petbattleover(self,event,arg1,...)
	local key = rematchsettings.loadedTeam
	if key and saved[key] then
		if route[key] then
			print("Press Alt, and then select the trainer")
		else
			print("No next target defined!")
		end
	end	
end
framebattle = CreateFrame("Frame", "RematchNextTarget");
framebattle:RegisterEvent("PET_BATTLE_OVER")
framebattle:SetScript("OnEvent", petbattleover);
framelog = CreateFrame("FRAME","RematchNextTarget");
framelog:RegisterEvent("ADDON_LOADED");
--framelog = CreateFrame("FRAME","RematchNextTarget");
framelog:RegisterEvent("PLAYER_LOGOUT");
framelog:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" then
		if arg1 == "RematchNextTarget" then
			local function copytable(db, defaults)
				if type(db) ~= "table" then db = {} end
				if type(defaults) ~= "table" then print("hmmm") return db end
				for k, v in pairs(defaults) do
					if type(v) == "table" then
						db[k] = copytable(db[k], v)
					elseif type(v) ~= type(db[k]) then
						db[k] = v
					end
				end
				return db
			end
			--print("first stage")
			myAllianceroute = copytable(myAllianceroute, allianceDefaultRoute) 
			--print("second stage")
			--iekava = 7
			myHorderoute = copytable(myHorderoute, hordeDefaultRoute) 
			--if (myAllianceroute == nil) then myAllianceroute = getAllianceRoute() end
			--if (myHorderoute == nil) then myHorderoute = getHordeRoute() end
			--print("third stage")
			if UnitFactionGroup("player") == "Horde" then route = myHorderoute; end
			if UnitFactionGroup("player") == "Alliance" then route = myAllianceroute; end
			--self:UnregisterEvent("ADDON_LOADED")
		else 
			--print("rematch",arg1)
		end
	else
		if event == "PLAYER_LOGOUT" then
			--iekava = 10
			if route == nil then print("wonderfull") end
			if UnitFactionGroup("player") == "Horde" then myHorderoute = route; end
			if UnitFactionGroup("player") == "Alliance" then myAllianceroute = route; end
		end
	end
end)




rematch:InitModule(function()
	saved = RematchSaved
end)

SLASH_RMTNXT1 = "/rmtnxt";
function SlashCmdList.RMTNXT(msg)
	if msg == "" then
		if UnitFactionGroup("player") == "Horde" then temp = "horderoute"; end
		if UnitFactionGroup("player") == "Alliance" then temp = "allianceroute" end
		print("printing ",msg," ", temp);
		--print(Addon)
		print(iekava)
		print(myHorderoute)
		print(myHorderoute[83837])
	end
	if msg == "reset1" then
		if myAllianceroute == nil or (myAllianceroute == {}) then print("ohohoho1") end
		if myHorderoute == nil or (myHorderoute == {}) then print("ahahaha1") end
		myHorderoute = nil
		myAllianceroute = nil
		print("reseted to nil")
	end
	if msg == "reset2" then
		myAllianceroute = allianceDefaultRoute
		if myAllianceroute == nil then print("ohohoho") end
		myHorderoute = hordeDefaultRoute
		if myHorderoute == nil then print("ahahaha") end
		print("end")
		route = {}
		if UnitFactionGroup("player") == "Horde" then route = myHorderoute; end
		if UnitFactionGroup("player") == "Alliance" then route = myAllianceroute; end
		if route == nil or (route == {}) then print("Amazing") end
	end
end
local function my_PLAYER_TARGET_CHANGED(self)
	--local saved = RematchSaved
	local name,npcID = rematch:GetUnitNameandID("target")
	print (name, " ",npcID) -- code to check to verify the accuracy of the NPC ID - name of NPC table
	local namefromtable = rematch.notableNames [npcID]
	if namefromtable then
		if name ~= namefromtable then
			print (format("%s does not match %s",name,namefromtable))
		end
	end
	if route[npcID] then
		local key = route[npcID]
		if key then
			if saved[key] then
				local nxttrgt = rematch.notableNames[key]
				print(format("Loaded team for %s.",nxttrgt))
				rematch:LoadTeam(key)
			end
		end
	end
end
function Rematch:PLAYER_TARGET_CHANGED()
	if IsAltKeyDown() then
		local name,npcID = rematch:GetUnitNameandID("target")
		return my_PLAYER_TARGET_CHANGED(self)
	else
		if IsControlKeyDown() then
			local name,npcID = rematch:GetUnitNameandID("target")
			
		else
			return old_PLAYER_TARGET_CHANGED(self)
		end
	end
end

